/// <reference path="../typings/jquery/jquery.d.ts"/>
/* global chrome */

var {debug} = require(['logger'], function(l){debug = l.debug});
var NSLibrary = NSLibrary || {};
var API_Methods = this;
var Device;

// var NC_ACCEPT;

// Unused Variable.
// var CHROME_VERSION = navigator.userAgent.match(/Chrome\/(\d+)/i)[1] || 0;
NSLibrary.Chrome = NSLibrary.Chrome || {};
// NSLibrary.Comms = NSLibrary.Comms || {};
// import Device from "./device.js";

NSLibrary.events = NSLibrary.events || {
    ack: new NSLEvent('ack')
};

function NSLEvent(name)
{
    return { name: name, event: new Event(name) };
}

// NSLibrary.Comms = NSLibrary.Comms || {};
// NSLibrary.Comms.WebSockets = NSLibrary.Comms.WebSockets || {};

// var setupHandle = function(){ };
var surveyAnswered = false;
// var gaBig = []; // for assembling big packets. each item is (0:cid, 1:id, 2:str, 3:tot)
var gApproved = "";

// var gSurveyNotification;
// var websocket;
// WebSockets
var sockets;
var thumbnailTimer;
var tmpSender = "";
var gLatLng;

// var View = NSLibrary.Client.View;
// var Chat = NSLibrary.Client.Chat;
// var UserAck= NSLibrary.Client.UserAck;
NSLibrary.Client = NSLibrary.Client || {};
var { View = null, UserAck = null } = NSLibrary.Client;

var pinWebSocket;
var gHeartBeat = { event: null, action: null };
// var gControlName = "";
// var gThumbnailType = "image/png";
var productCode = 0;
var i17n = new ArrayBuffer(32);
new Uint32Array(i17n).set([
  2119247752,
  3830839039,
  2755063126,
  1614632788,
  1971797310,
  694919190,
  868398436,
  2758864662
]);

// SCRIPT TO OBTAIN PRODUCT CODE for CONNECTION ISSUE
var $ = (window && window.$) || null;
if ($) {
  $.getJSON("/oem.json", function(data) {
    $.each(data, function(key, val) {
      if (key === "product") {
        productCode = val;
      }
    });
  });
}

var UTF8 = NSLibrary.UTF8;

/*jslint regexp: false*/
/*jshint regexp: false*/
// var reconnectWorker = new Worker("/js/reconnectWorker.js");

var tcpPage;
var tcpConnected = 0;

localStorage.approvedWebList = '';

var tcpPageId;

var gThumbWidth;
var gThumbHeight;
var gWebflag;
var gRedirect;
var gIncludes = [];
var gExcludes = [];

var gPin;

var gUsedMacAddress;
var gUsedIPAddress;

// short versions of zero for 1,2 and 4 byte values
let z = String.fromCharCode(0);
let z2 = z + z;
let z3 = z2 + z;
let z4 = z2 + z2;

  require([
      'settings',
      'background/storage',
      'pubsub',
      'comms.nc',
      'lib/batch',
      'student',
      'device',
      'chatlib',
      'models/Tab',
      'comms.commands',
      'comms.websocket',
      'models/useridentity',
      'models/register',
      'modules/extension',
      'modules/initialize',
      'modules/image',
      'disconnect',
      'socket',
      'background/events',
      'on/lifecycle'
  ], function(
        settings,
        storage,
        PubSub,
        NC,
        sq,
        CSParams,
        Device,
        Chat,
        Tab,
        COMMANDS,
        WSComms,
        identity,
        Register,
        extension,
        initialize,
        Image,
        disconnect,
        Socket,
        lifecycle){

          // Bind to this
          // NSLibrary.Comms = Comms;
          extension.bind(API_Methods);

          if (!localStorage.clientName){
            identity.refresh.user()
            .then(setUserDetails)
            .catch(e => { if(e != "no-identity") {
              console.trace(e);
            }});
          }

              NSLibrary.settings = settings;

              COMMANDS.process.HANGUP = Hangup;

              window.CSParams = CSParams;
              /* Required for Export */
              // NSLibrary.Comms.NC = NC;
              //

              PubSub.subscribe("senddata", function(params){
                  extension.senddata(params.cid, params.message);
              });

              PubSub.subscribe("updateSM", function(params){
                  if (params.value=="splice"){
                      //Remove the connection
                      delete CSParams.Connections[params.cid];
                      return;
                  }

                  CSParams.Connections[params.cid].sm = params.value;
                  // Send any cached requests
                  extension.sendHelpRequest();
              });

              // TODO: Runtime Connect listener
              chrome.runtime.onConnectExternal.addListener(function(port) {
                // Accept instructions ONLY from authorised TCP Connect.
                if (tcpPageId !== undefined && port.sender && port.sender.id == tcpPageId) {
                  port.onMessage.addListener(function(msg) {
                    //console.log(msg);
                    tcpConnected = 1;
                    var data = String.fromCharCode(0, 0, 0, 0) + msg.data;

                    if (msg.nc) {
                      NC.Process(data);
                    }
                  });
                }
              });

              chrome.management.getAll(function(extensions) {
                for (var i = 0; i < extensions.length; i++) {
                  if (extensions[i].name.indexOf("TCP Connect") != -1) {
                    tcpPageId = extensions[i].id;
                    chrome.management.launchApp(tcpPageId);
                    tcpPage = chrome.runtime.connect(tcpPageId);
                    tcpPage.postMessage({
                      clientName: localStorage.clientName,
                      macAddress: localStorage.macAddress,
                      roomName: localStorage.room
                    });
                    break;
                  }
                }
              });

              // Storage Listeners
              // TODO: Runtime Storage listener
              chrome.storage.onChanged.addListener(NSLibrary.settings.handleChange);


              // Runtime Listeners
              if (chrome.runtime)
              {
                  if (chrome.runtime.onMessage){
                      // TODO: Runtime Message listener
                      chrome.runtime.onMessage.addListener(NSLibrary.settings.runtimeMessage);
                  }

                  if (chrome.runtime.onStartup)
                  {
                      // TODO: Runtime Startup listener
                      chrome.runtime.onStartup.addListener(restoreLastRoom);
                  }

                  if (chrome.runtime.onConnectExternal){
                      // TODO: Runtime External Connect listener
                      chrome.runtime.onConnectExternal.addListener(function(port) {
                          // Accept instructions ONLY from authorised TCP Connect.
                          if (tcpPageId !== undefined && port.sender && port.sender.id ==tcpPageId)
                          {
                              port.onMessage.addListener(function(msg) {
                                //console.log(msg);
                                tcpConnected = 1;
                                var data = String.fromCharCode(0,0,0,0) + msg.data;

                                if (msg.nc){
                                    NC.Process(data);
                                }
                              });
                          }
                      });
                  }
              }

              function UpdateMetaOptions(options){
                  debug('UpdateMetaOptions');

                  if (options.passKey) {
                      debug('dispatchUOMessage');
                      //var data =
                      NSLibrary.settings.update.options(options.passKey.newValue || options.passKey);
                      // TODO: Extension Request dispatcher
                      //chrome.extension.onRequest.dispatch({method: 'updateOptions', data: ()}, );
                  } else if (options.options && options.options.passKey) {
                      // options update, passKey has just been changed.
                      NSLibrary.settings.update.connection(options.options, options.options.passKey)
                      .then(ReRunSetup);
                  } else {
                      NSLibrary.settings.update.pfxClear();
                  }

                  if (options.resetClientName) {
                    identity.refresh.user()
                    .then(setUserDetails)
                    .catch(e => { if(e != "no-identity") {
                      console.trace(e);
                    }});
                  }
              }

              function ReRunSetup(data){
                  return new Promise(function(resolve){
                      // Promise (success, failure)
                      if (!CSParams.Opened){
                        initialize();
                      }

                      resolve(data);
                  });
              }

              displaySize();
              
              function displaySize()
              {
                return new Promise(function(resolve, reject) {
                  Image.setDisplaySize( window.screen.width, window.screen.height);
                  resolve({ width: window.screen.width, height: window.screen.height });
                });
              }


              Promise.all([
                settings.get.managed(),
                identity.refresh.device(),
                identity.refresh.user()
              ]).then(function(args)
                {
                  var options  = args[0];
                  var deviceId = args[1];
                  var userName = args[2];

                  var userIndex = userName.indexOf("@");
                  var currentUser = '';

                  if (userIndex){
                    currentUser = userName.substring(0,userIndex);
                  }

                  if (deviceId){
                    // Device
                    localStorage.macAddress = (options && options.useFullDeviceIdentifier) ? deviceId.long : deviceId.short.substring(0,12);
                  } else {
                    // User
                    if (!localStorage.macAddress|| localStorage.macAddress == "undefined")
                    {
                      localStorage.macAddress = currentUser.replace(/\s/g, "").substring(0,12).toUpperCase();
                    }
                  }

                  if (!localStorage.clientName || options && options.resetClientName)
                  {
                    if (userIndex)
                    {
                      localStorage.clientName = currentUser.replace(/\s/g, "").substring(0,30).toUpperCase();
                      localStorage.userName = userName;
                    }
                  }
                })
                .catch(e => { if(e != "no-identity") {
                  console.trace(e);
                }});

              // Hook
              // setupHandle = setup;





              var localOptions = NSLibrary.settings.get.local();
              var managedOptions = NSLibrary.settings.get.managed();

              Promise.all([localOptions, managedOptions]).then(function(items) {
                  var local = items[0];
                  var managed = items[1];

                  if (managed) {
                      if (managed.options) {
                          debug("MO - Mismatch!");
                      }

                      debug("managed Option Update");
                      UpdateMetaOptions(managed);
                  } else if (local) {
                      debug("local Option Update");
                      UpdateMetaOptions(local);
                  }

                  debug("load complete, entering setup");
                  initialize();
              });


              // SOCKETS CLASS

              // get Windows sizes
              if (chrome.windows)
              {
                  // TODO: Window FocusChange listener
                  chrome.windows.onFocusChanged.addListener(focusChanged);
                  chrome.windows.getCurrent(
                      function(w) {
                          View.width = w.width - 16;
                          View.height = w.height - 101;
                          View.gridSizeX = View.width;
                          View.gridSizeY = 32;
                          View.canvas.width = View.gridSizeX;
                          View.canvas.height = View.gridSizeY;

                          View.nrX = Math.round(View.width / View.gridSizeX);
                          View.nrY = Math.round(View.height / View.gridSizeY);
                          View.pixelCount = (View.gridSizeX * View.gridSizeY) * 4;
                          CSParams.ScreenDimensions.width = w.width -16;
                          CSParams.ScreenDimensions.height =  w.height - 101 -5; //101 is fun value that i chose at random - 5 is for the border (including 1 for luck)
                  });
              }

              // Listeners
              function focusChanged()
              {
                CSParams.get.currentWindow()
                .then(Tab.updateCurrentWebsite)
                .then(d => {console.info("focused:", d.id)})
                // .then(NC.SendWSlave)
                // .then(function(View){
                //   View.getScreen();
                // })
                .catch(function(error){
                  debug("error in focusChanged: " + error);
                });
              }

              window.addEventListener('storage', storage.handler);

              PubSub.subscribe('windowResize', function()
              {
                  CSParams.get.currentWindow()
                  // .then(NC.SendWSlave)
                  .then(sq.squash(sq.token.windowResize, 300))
                  .then(function(View){
                    debug('resize__getScreen');
                    View.getScreen();
                  })
                  .catch(function(error){
                    debug("error in windowResize: " + error);
                  });
              });

              // Listeners
              function Hangup(d){
                  debug('HANGUP RECEIVED');
                  CSParams.reconnectMode.active = 0;
                  if (WSComms.instance.websocket.readyState == 1){
                    chrome.storage.local.set({ connectionState: "connected_NCS" });
                    clearTimeout(CSParams.reconnectMode.expiryHandler);
                    CSParams.reconnectMode.expiryHandler = setTimeout(CSParams.reconnectMode.clear, 10000);
                  } else {
                    chrome.storage.local.set({ connectionState: "disconnected" });
                  }

                  var cidIndex = d.indexOf('CONNECTION_ID=');
                  var termIndex = d.indexOf('\n', cidIndex + 14);
                  var cidt = d.substring(cidIndex + 14, termIndex);

                  debug('HANGUP CONNECTION: ' + cidt);
                  WSComms.instance.HANGUP(cidt);
                  if (CSParams.ActiveConnection && CSParams.ActiveConnection.cidt === cidt)
                  {
                      debug('HANGUP on Active Connection');
                      CSParams.powerMode = null;
                      window.setTimeout(Device.power.switchMode,90000);
                      debug('(HANGUP) 90S switch powerMode: ' + CSParams.powerMode);
                  }

                  var found = false;
                  for (var conn in CSParams.Connections) {
                      if (CSParams.Connections[conn].cidt == cidt) {
                          debug("REMOVE:" + cidt);
                          delete CSParams.Connections[conn];
                          found = true;
                          if (CSParams.ActiveConnection.cid === conn)
                          {
                              disconnect.reset(true, { code:1000, message:'HANGUP Received' });
                              CSParams.ActiveConnection = undefined;
                          } else {
                            // TODO: PUT THIS BACK IN
                            // TODO: (MAYBE?)
                            window.setTimeout.call(window,() => {let chat = Chat.instance();
                                                                 if(chat) {chat.endChat()}}, 5000);
                            // setTimeout(Chat.endChat, 5000);
                          }
                          window.clearInterval(CSParams.tickle[conn]);
                          delete CSParams.tickle[conn];
                          break;
                      }
                  }

                  // if (!found) {
                  //   debug('onhangup: ' + d);
                  //   //alert("onhangup: " + d);
                  // }

              }

    // END OF INCLUDED SEGMENT
    // Public API



    function hangupAndCloseConnection()
    {
      if (CSParams.ActiveConnection && WSComms.instance.websocket.readyState === 1) {
        WSComms.instance.HANGUP(CSParams.ActiveConnection.cidt);
      }

      closeConnection();
    }

    function closeConnection(reason)
    {
      chrome.storage.local.set({ connectionState: "disconnected" });
      debug('CloseConnection');
      if (WSComms.instance.websocket && WSComms.instance.websocket.readyState == 1){
        debug('Socket is currently open.');
        WSComms.mechanism.CLOSE();
      }

      reason = (reason)? reason : { code:1000, message: 'closeConnection' };
      disconnect.reset(false, reason);
      CSParams.Opened = false;
    }

/**
DISCCONNECT SECTION
**/
    // function doDisconnect(keepOpen, reason)
    // {
    //     return disconnect.reset(keepOpen, reason);
    // }

    function sendQAResponse(time, answer)
    {
      senddata(csParams.QA.Cid, String.fromCharCode(198, 0, 198, 0, 0, 0, 1, 0, csParams.QA.RoundNum, 0, 0, 0, time, 0, 0, 0) + answer + String.fromCharCode(0));
    }

    function sendFeedbackResponse(selected)
    {
      senddata(csParams.Feedback.Cid, String.fromCharCode(236,0,0,0,selected,0,0,0));
    }

    /**
     * Tab Events
     */
    if (chrome.tabs)
    {
        // TODO: Tab Activated listener
        chrome.tabs.onActivated.addListener(tabActivation);
        // TODO: Tab Updated listener
        chrome.tabs.onUpdated.addListener((tabid, changeinfo, tab) => Tab.Update(tabid, changeinfo, tab));
        chrome.tabs.onRemoved.addListener(t => Tab.clearId(t))
        chrome.tabs.onReplaced.addListener(t => Tab.replace(t))
    }

    function tabActivation(activeInfo)
    {
        // debug("tab activated: [" + activeInfo.windowId + "]:" + activeInfo.tabId);

        onTabChanged();
        //getSelectedWindow();

        // Replaced pollSelectedTab with Tab.updateCurrentWebsite;
        Tab.updateCurrentWebsite({id:activeInfo.windowId});
        // Tab Selected is activeInfo.tabId
        // pollSelectedTab();

    }

    function onTabChanged()
    {
        for (var cid in CSParams.Connections)
        {
            var connection = CSParams.Connections[cid];
            if (connection.thumbi)
                connection.thumbs = connection.thumbi; // ensure onInterval calls takeScreenshot
        }
    }


    function setUserDetails(userName) {
      var userIndex = userName.indexOf("@");
      var currentUser = '';

      if (userIndex){
        currentUser = userName.substring(0,userIndex);
      }

      localStorage.clientName = currentUser.replace(/\s/g, "").substring(0,30).toUpperCase();
      localStorage.userName = userName;
    }


    function restoreLastRoom()
    {
        debug('Chrome Started - Load last Session room');
        chrome.storage.local.get("lastRoom", function(store){
            debug("lastRoom Loaded");
            if (store.lastRoom)
            {
                debug(store.lastRoom);
                sessionStorage.room = store.lastRoom;
            }
        });
    }
});


// END OF AMD Section

// PUBLIC API Methods

// Chrome Tab events

// function getRoomType() {
//     return localStorage.roomType;
// }
//
// function getRoomList() {
//     return localStorage.roomList;
// }

function gd()
{
    return i17n;
}
