//
// require(['settings'], function(settings){

//
  // PRE:



      // PICK
      // .then(function([comms, transmit, conf]) {

      // UNPICK
      // })
      // .catch((e) => {
      //     console.error("Failed to load managed settings:", e);
      // });


// });

"use strict";
console.log("/js/comms.webrtc.js");
//   NSLibrary.settings = settings;
(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      //
      // var module = module || null;
      // var NSLibrary = NSLibrary || {};
      // NSLibrary.Comms = NSLibrary.Comms || {};
      // NSLibrary.settings = NSLibrary.settings || {};

      define(['settings'], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
        require('settings')
      );
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(this, function(Settings) {
  let moduleName = "webrtc";
  let state = null;
  const triggers = {};
  let config = null;
  let hooks = {};

  function webrtc([configuration, subscribe, dispatch]) {
      console.log('webrtc - Legacy mode');
      // Set the global config reference
      config = configuration;
      hooks = { subscribe, dispatch };

      // if (!config || !config().host) {
      //     console.log("Waiting for peer", config());
      //     return true;
      // }

      console.log("WebRTC loading ...", config());
      console.log("Hosting APP", hooks);

      // Detach from the Promise
      // setTimeout(main, 500);

      // We return "true" to the Promise
      // so we can catch runtime errors locally,
      // otherwise errors are caught by Promise.catch()

      return true;
  }

  // Settings
  //     .load(moduleName)
  //     .then(defaults => {
  //         let extension = {};
  //         function conf(extend) {
  //             // cache the extended properties ...
  //             if (extend && extend.constructor === Object) extension = { ...extend };
  //
  //             return {
  //                 ...defaults,
  //                 ...extension
  //             };
  //         }
  //
  //         return [NSLibrary.Comms, NSLibrary.Transmit, conf];
  //     })

  function main() {
    let cfg = config();
    hooks.subscribe()
  }
  //
  // let clientId = NaN;
  // let state = null;
  //
  // const triggers = {};
  // const ncJsonSchema = [
  //     { name: "cid", index: 4, type: "number" },
  //     { name: "cmd", index: 2, type: "number" },
  //     { name: "empty", index: 2, type: "number" },
  //     { name: "payload", index: 0, type: "json" }
  // ];
  //
  // // Create Message Listeners
  // bindMessageTriggers();
  // resetState(state);
  // state.ready = true;
  //
  //
  //
  // function test(cid) {
  //     clientId = Number(cid);
  //     const rows = [
  //         { key: "joined", value: 2 },
  //         { key: "elect", value: true },
  //         { key: "message", value: "start" }
  //     ];
  //     rows.forEach((row, i) =>
  //         // setTimeout(() => NSLibrary.Comms.webrtc.delegate(cid, row), i * 100)
  //         setTimeout(() => delegate(cid, row), i * 100)
  //     );
  // }
  //
  // function parse(clientIdString, ncJsonPacket) {
  //     // sets global vairables and parses NC package
  //     const {payload} = unpack(ncJsonPacket, ncJsonSchema);
  //     delegate(clientIdString, payload);
  // }
  //
  // function delegate(cid, payload) {
  //     clientId = Number(cid);
  //     const { key = null, value = null, extra = null } = payload;
  //
  //     // these triggers require election
  //     const filter = ["candidate", "answer", "offer"];
  //
  //     if (filter.indexOf(key) + 1 && !state.elected) {
  //         console.log("Key [%s] requires election.", key);
  //         return;
  //     }
  //
  //     if (triggers[key]) {
  //         return triggers[key](value, extra);
  //     }
  //
  //     console.warn("NO TRIGGER !!!!!!!!!", key, value);
  // }
  //
  // ////////////////////////////////////////////////////
  //
  function start() {
      // the stream initiator is not the moderator
      // if (state.moderator) return;

      // AUTOSTART (FD Thumbnails)
      // if (!state.elected) {
      //     console.log("Start rejected. PEER not elected");
      //     return;
      // }

      state.initiator = true;

      chooseDesktopMedia()
      .then(settings => {
          navigator.mediaDevices
              .getUserMedia(settings)
              .then(stream => {
                  // console.log('Adding local stream.');
                  state.local = stream;
                  emit("streaming");
                  if (state.initiator) {
                    // TODO: Leave stream running;
                      // makeConnection();
                  }

                  bindMediaOnEnd(stream);
              })
              .catch(e => {
                  resetState();
                  console.warn(e);
                  emit("rejected")
              });
      });
  }
  //
  // // TODO: Temporary Fix;
  // start();
  //
  function chooseDesktopMedia() {
      // get media dimension etc (aka constraints)
      // screen, window and tab option in chooser
      let { constraints, sourceType } = conf();

      // shallow copy that is augmented and returned
      let settings = { ...constraints };
  
      // browser media (webcam)
      if (!isChromeExtension()) {
          return new Promise(resolve => {
              resolve(settings);
          });
      }

      // Remove  any illegal sourceTypes
      const accepted = ["screen", "window", "tab"];
      sourceType.map(a => `${a}`.toLowerCase()).filter(k => accepted.indexOf(k) + 1);

      // extension media (desktop)
      return new Promise(resolve => {
          chrome.desktopCapture.chooseDesktopMedia(sourceType, (streamId, options) => {
              console.log("chooseDesktopMedia", sourceType, streamId, options);

              // spread the conf constraints values
              // and add chrome specific stuff
              settings = {
                  ...settings,
                  video: {
                      mandatory: {
                          chromeMediaSource: "desktop",
                          chromeMediaSourceId: streamId
                      }
                  },
                  audio: options.canRequestAudioTrack
              };

              resolve(settings);
          });
      }).catch((err) => {
              console.log("desktopCapture failed");
      });
  }
  //
  // function setDescription(value, callback) {
  //     callback = callback || function() {};
  //     state.conn
  //         .setRemoteDescription(new RTCSessionDescription(value))
  //         .then(() => callback())
  //         .catch(e => {
  //             console.log("Description error", e);
  //         });
  // }
  //
  // function makeConnection() {
  //     if (!(state.channelReady && !state.started && state.local)) return;
  //
  //     createPeerConnection();
  //     state.conn.addStream(state.local);
  //
  //     if (state.initiator) doCall();
  //
  //     state.started = true;
  // }
  //
  // function createPeerConnection() {
  //     try {
  //         console.log("Created RTCPeerConnnection");
  //         let { iceServers, useIceServers } = conf();
  //         iceServers = useIceServers ? iceServers : [];
  //         state.conn = new RTCPeerConnection({ iceServers });
  //         state.conn.onicecandidate = handleIceCandidate;
  //         state.conn.onaddstream = handleRemoteStreamAdded;
  //         state.conn.onremovestream = handleRemoteStreamRemoved;
  //         // state.conn.onconnectionstatechange = handleCloseConnection;
  //     } catch (e) {
  //         console.log("Failed to create PeerConnection, exception: " + e.message);
  //         alert("Cannot create RTCPeerConnection object.");
  //     }
  // }
  //
  // function bindMediaOnEnd(stream) {
  //     stream.getVideoTracks()[0].onended = () => {
  //         console.log("media track ended!");
  //         emit("stop");
  //         resetState();
  //     };
  // }
  //
  // function handleIceCandidate(e) {
  //     if (!e.candidate) return console.log("End of candidates.");
  //
  //     const { sdpMLineIndex, sdpMid, candidate } = e.candidate;
  //
  //     emit("candidate", {
  //         type: "candidate",
  //         label: sdpMLineIndex,
  //         id: sdpMid,
  //         candidate: candidate
  //     });
  // }
  //
  // function handleCreateOfferError(event) {
  //     console.log("createOffer() error: ", event);
  // }
  //
  // function doCall() {
  //     console.log("Sending offer to peer");
  //     state.conn.createOffer(setLocalAndSendMessage, handleCreateOfferError);
  // }
  //
  // function doAnswer() {
  //     console.log("Sending answer to peer.");
  //     state.conn.createAnswer().then(setLocalAndSendMessage, onCreateSessionDescriptionError);
  // }
  //
  // function setLocalAndSendMessage(sessionDescription) {
  //     console.log("setLocalAndSendMessage sending message", sessionDescription);
  //
  //     // this can be either "offer" or "answer" depending on the type
  //     // see doAnswer() and doCall() callbacks
  //
  //     console.log(
  //         "%cSTATE:[%s]",
  //         "background:lightblue;color:black",
  //         state.conn.signalingState
  //     );
  //     state.conn.setLocalDescription(sessionDescription);
  //     const { type, sdp } = sessionDescription;
  //     // sendMessage(sessionDescription);
  //     emit(type, { sdp, type });
  // }
  //
  // function onCreateSessionDescriptionError(error) {
  //     console.warn("Failed to create session description: " + error.toString());
  // }
  //
  // function handleRemoteStreamAdded(event) {
  //     console.log("Remote stream added.");
  //     state.remote = event.stream;
  //     state.video.srcObject = state.remote;
  //     state.video.style.display = "block";
  // }
  //
  // function handleRemoteStreamRemoved(event) {
  //     console.log("Remote stream removed. Event: ", event);
  // }
  //
  // function handleRemoteHangup() {
  //     console.log("Session terminated.");
  //     resetState();
  // }
  //
  // function resetState(prev, ready = false) {
  //     // check previous state and reset to default
  //     // close open connections, streams etc.
  //
  //     prev = prev || state || null;
  //
  //     prev && prev.local ? prev.local.getTracks().forEach(t => t.stop()) : null;
  //     prev && prev.remote ? prev.remote.getTracks().forEach(t => t.stop()) : null;
  //     prev && prev.conn ? prev.conn.close() : null;
  //
  //     const videoEl = document.querySelector("#remoteVideo");
  //
  //     const zeroState = {
  //         moderator: false,
  //         room: conf().room || null,
  //         window: null,
  //         ready: false,
  //         elected: false,
  //         channelReady: 0,
  //         initiator: false,
  //         started: false,
  //         local: null,
  //         remote: null,
  //         conn: null,
  //         video: videoEl
  //     };
  //     // return a shallow copy
  //     state = { ...zeroState, ready };
  // }
  //
  //
  // function emit(key = "text", value = null, target = null) {
  //     let message = { key, value, target };
  //     const data = JSON
  //         .stringify(message)
  //         .split("")
  //         .map(c => c.charCodeAt(0)).join("");
  //
  //     const CID = String.fromCharCode(Number(clientId));
  //     const CMD = String.fromCharCode(235,0); // NC_JSON
  //     const bytes = [ CMD, data ].join("");
  //
  //     console.log("%cEMIT: %s", "background: LightBlue;", key, message);
  //
  //     Transmit.senddata(CID, bytes);
  // }
  //
  // function unpack(bytePacket, byteSchema) {
  //     // returns Object literal of the input arguments
  //     // according to the packet schema definition
  //
  //     const data = {};
  //     const array = bytePacket.split("").map(c => c.charCodeAt(0));
  //
  //     // Divide the byte packets into Integer Arrays
  //     byteSchema.forEach(row => {
  //         const { name, index } = row;
  //         return index
  //             ? // if the index is > 0 continue to splice the array
  //               (data[name] = array.splice(0, index))
  //             : // otherwise presume the rest is the payload
  //               (data[name] = array);
  //     });
  //
  //     // Cast the parts as Primitives
  //     byteSchema.forEach(row => {
  //         const { name, type } = row;
  //         let value = data[name];
  //         switch (type) {
  //             case "json":
  //                 value = String.fromCharCode(...value);
  //                 value = value.match(/^[^\{]*?(\{.*\})[^\}]*?$/)[1];
  //                 value = JSON.parse(value);
  //                 break;
  //
  //             case "number":
  //                 value = value.reduce((a, c) => a + c);
  //                 break;
  //
  //             case "string":
  //             default:
  //                 value = String.fromCharCode(...value);
  //                 break;
  //         }
  //         data[name] = value;
  //     });
  //
  //     return data;
  // }
  //
  // function checkClientId(id) {
  //     return String(clientId) === String(id);
  // }
  //
  function isChromeExtension() {
      return (chrome && chrome.desktopCapture) || false;
  }
  //
  // // RENAMED function createMessageListeners() {
  // function bindMessageTriggers() {
  //     addMessageListener("created", function(room) {
  //         console.log("Created room " + room);
  //         // state.initiator = true;
  //     });
  //
  //     addMessageListener("ready", function(room) {
  //         console.log("Attempting to join", room);
  //         emit("join", room);
  //     });
  //
  //     addMessageListener("full", function(room) {
  //         console.log("Room " + room + " is full");
  //     });
  //
  //     addMessageListener("joined", function(room, count) {
  //         // @count is the number of socket connections
  //         // issued by the server, for PEERs in @room
  //         console.log("joined: " + room);
  //         state.channelReady = Number(count);
  //     });
  //
  //     addMessageListener("log", function(array) {
  //         console.log(array);
  //     });
  //
  //     addMessageListener("stop", function() {
  //         console.log("Stream has stopped. Close viewer window");
  //         resetState();
  //
  //         if (!chrome || !chrome.app.window || !chrome.app.window.get) return;
  //         const createdWindow = chrome.app.window.get("webrtcviewer");
  //         createdWindow && createdWindow.close();
  //     });
  //
  //     addMessageListener("elect", function(value) {
  //         // state.elected = checkClientId(value.clientId);
  //         state.elected = value;
  //
  //         console.log("ELECTED", state.elected);
  //     });
  //
  //     addMessageListener("prepare", makeConnection);
  //
  //     addMessageListener("candidate", function(value) {
  //         if (state.started) {
  //             const { label, candidate } = value;
  //             var newCandidate = new RTCIceCandidate({
  //                 sdpMLineIndex: label,
  //                 candidate: candidate
  //             });
  //             state.conn
  //                 .addIceCandidate(newCandidate)
  //                 .then(() => {
  //                     console.log("added new RTC Ice Candidate");
  //                 })
  //                 .catch(() => {
  //                     console.log("Failed to added new RTC Ice Candidate");
  //                 });
  //         }
  //     });
  //
  //     addMessageListener("offer", function(value) {
  //         if (!state.initiator && !state.started) makeConnection();
  //         if (!state.conn) createPeerConnection();
  //         setDescription(value, doAnswer);
  //     });
  //
  //     addMessageListener("answer", value => {
  //         state.started && setDescription(value);
  //     });
  //
  //     // A listerner for generic "message" messages, as emited by sendMessage()
  //     addMessageListener("message", function(message) {
  //         const key = message.constructor === Object ? message.type : message;
  //         switch (key) {
  //             case "start":
  //                 start(); //! required
  //                 break;
  //
  //             case "bye":
  //                 handleRemoteHangup();
  //                 break;
  //
  //             case "ready":
  //                 emit("join");
  //                 break;
  //             default:
  //                 console.log("DROP-THROUGH", key, message);
  //                 break;
  //         }
  //     });
  // }
  //
  // function addMessageListener(trigger, fn) {
  //     console.log("ON [%s]", trigger);
  //     triggers[trigger] = fn;
  // }

  return {
      // main subroutine (Legacy)
      webrtc,

      // Modular approach
      start,

      // methods for unit testing
      // setDescription,
      // makeConnection,
      // createPeerConnection,
      // bindMediaOnEnd,
      // handleIceCandidate,
      // handleCreateOfferError,
      // doCall,
      // doAnswer,
      // setLocalAndSendMessage,
      // onCreateSessionDescriptionError,
      // handleRemoteStreamAdded,
      // handleRemoteStreamRemoved,
      // handleRemoteHangup,
      // resetState,
      // requestScreen,
      // emit
  };

}));

