(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define(['plugin'], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
        require('plugin')
      );
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(this, function(Plugin) {

  class TabData {
      constructor(){
    }

    static send(tab){
      Plugin.appStart(tab.id);
      // sendAppActivate(tabid);
      Plugin.appChange(tab.url,tab.title, tab.id);
      Plugin.webStart(tab.url, tab.title, tab.id);
      Plugin.appActivate(tab.id);
    }
  }

  return TabData;
}));
