(function (factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define([
        'on/plugin',
        'on/heartbeat',
        'on/reconnect',
      ], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
        require('on/plugin'),
        require('on/heartbeat'),
        require('on/reconnect')
      );
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(() => {
// CSParams.lifecycle:
// {
//  time:0,
//  active:new Event('nc') // increments timestamp (lifecycle.isActive)
// , isActive: null,       // now lifecycle.check
// Interval:new Event('interval'), //
// HeartBeat:new Event('heartbeat'), //
// socketOpeningtHandshake: undefined
// },
}));
