// NSLibrary.Translate();
// window.onload = function () {
	require(['modules/translate'], t=>t());

	var bgPage = chrome.extension.getBackgroundPage();

	imageSet = "#set" + bgPage.Feedback.ImageSet;
	image = imageSet + " img";
	format = bgPage.Feedback.ButtonConfiguration;
	question = bgPage.Feedback.Question;
	//answers = bgPage.Feedback.AnswerText;  // not used yet
	numberAnswers = bgPage.Feedback.NumberAnswers;

	$(document).ready(function () {

		$('<p>' + question + '</p>').appendTo('#question');

		numItems = numberAnswers;

		start = 4.72; //number between 0 and 2pi
		step = (2 * Math.PI) / numItems;

		if (format === 1 && numberAnswers > 4) {
			for (i = 0; i < numberAnswers; i++) {
				btnNumber = i + 1;

				image = createImage(btnNumber);
				radius = ($('#set').width() - $(image).width()) / 2;

				posTop = (($('#set').height() / 2) + radius * Math.sin(start)) - ($(image).height() / 2);
				posLeft = (($('#set').width() / 2) + radius * Math.cos(start)) - ($(image).width() / 2);
				start += step;

				btnNumber = i + 1;
				image.css("top", posTop + 40);
				image.css("left", posLeft);
			}

		} else {

			if(numberAnswers>8){
				start = -215;
			}

			html = "<br> <br> <br> <br> <br> <br> <br> <br> <br> ";
			html = $.parseHTML(html),
				$('#set').html(html);

			if (numItems == 2) {
				offset = $('#image').width() / 2 + 50;
			} else if (numItems == 3) {
				offset = $('#image').width() / 3 + 100;
			} else if (numItems == 4) {
				offset = $('#image').width() / 4 + 150;
			} else {
				offset = $('#image').width() / 4 + 175;;
			}


			for (i = 0; i < numberAnswers; i++) {
				iconNumber = i + 1;
				posLeft = start;

				if(numberAnswers>8){
					start += step * 215;
				}else{
					start += step * 150;
				}

				image = createImage(iconNumber);
				image.css("left", posLeft - offset);
			}
		}

		function createImage(iconNumber) {
			return $('<img />')
				.attr('src', 'data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7')
				.attr('class', "feedback imageS" + bgPage.Feedback.ImageSet + "_" + iconNumber)
				.click(function () {
					selection = this.className.split("_")[1].split(" ")[0];
					bgPage.sendFeedbackResponse(selection);
				})
				.hover(function () {
					$(this).addClass('hover');
				}, function () {
					$(this).removeClass('hover');
				})
				.appendTo($('#set'));
		}

	});
