var bgPage = chrome.extension.getBackgroundPage();

require(['modules/translate'], function(Translate){
  Translate();
  document.getElementById("helpBtn").addEventListener("click", function(){
    if (document.getElementById("helpMsg").value.length > 0){

      bgPage.sendHelpRequest(document.getElementById("helpMsg").value);
      document.getElementById("helpMsg").disabled = "disabled";
      var manifest = chrome.runtime.getManifest();

      bgPage.showHRNotification(manifest.icons["48"], manifest.name, Translate('CLIENT_IS_REQUESTING_HELP'));

      window.setTimeout(function(){window.close();},500);
    }
  });
});
