require(['modules/translate'], function(Translate){
    Translate();

    function showSurvey() {


      var btnColours = ['#3d77b2', '#4bad85', '#c0c0c0', '#cc4d35', '#c6b202', '#8d52ab'];
      // if (typeof(NSLibrary) != 'undefined') {
      //   NSLibrary.Translate();
      // }
      var bgPage = chrome.extension.getBackgroundPage();
      bgPage.surveyAnswered = false;

      var question = bgPage.getSurveyQuestion();
      var answers = bgPage.getSurveyAnswers();


      document.getElementById('surveyQuestion').innerHTML = question;

      var buttons = answers.split(',');
      var btnCount = 0;
      for (var button in buttons) {
        var newdiv = document.createElement('button');
        newdiv.style.cssFloat = 'left';
        newdiv.style.fontWeight = 'normal';
        newdiv.style.backgroundColor = btnColours[btnCount];
        newdiv.innerHTML = buttons[button];
        newdiv.onclick = answerBtnClick;

        if (buttons[button] != "") {
          document.getElementById('surveyAnswers').appendChild(newdiv);
          btnCount++;
        }
      }
      var maxWidth = 0;
      var allBtns = document.getElementsByTagName('button');
      var i;
      for (i = 0; i < allBtns.length; i++) {
        if (allBtns[i].clientWidth > maxWidth) {
          maxWidth = allBtns[i].clientWidth;
        }
      }

      for (i = 0; i < allBtns.length; i++) {
        allBtns[i].style.width = maxWidth;
      }

    }

    function answerBtnClick() {
      var bgPage = chrome.extension.getBackgroundPage();
      bgPage.surveyAnswered = true;
      bgPage.sendSurveyResponse(this.innerText);
    }

    showSurvey();
});
