var NSLibrary = NSLibrary || {};
NSLibrary.Client = NSLibrary.Client || {};
NSLibrary.Client.Clipboard = NSLibrary.Client.Clipboard || {};

(function(clipboard) {

    clipboard.getClipboardText = function() {
        var input = document.createElement('input');
        input.type = 'text';
        document.body.appendChild(input);
        input.focus();
        input.select();
        document.execCommand('paste');
        var retVal = input.value;
        document.body.removeChild(input);
        return retVal;
    };

    clipboard.setClipboardText = function(clipboardText) {
        var input = document.createElement('input');
        input.type = 'text';
        input.value = clipboardText;
        document.body.appendChild(input);
        input.focus();
        input.select();
        document.execCommand('copy');
        document.body.removeChild(input);
    };


})(NSLibrary.Client.Clipboard);
