(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define(['student','Transmit','background/subscription'], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
      require('student'),
      require('Transmit'),
      require('background/subscription'),
      );
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(this, function(CSParams, Transmit, Subscription) {
  new Subscription(Subscription.keys.plugin, sendPlugin).registerEvent(sendPlugin);
  function sendPlugin(event)
  {
      // Event handling
      var data = event.detail;
      var key = data.key;
      var value = data.value;

      // Comparison
      var needToSend = false;
      var valueArray = [].map.call(value, function(s){ return s.charCodeAt(0); });

      var oldContents = CSParams.pktCh[key];
      if (typeof(oldContents) ==='undefined' || oldContents.length !== valueArray.length)
      {
          needToSend = true;
      } else {
          for (var i in valueArray)
          {
              // THIS BIT HAS A BUG!!
              if (oldContents[i] !== valueArray[i]){
                  // values differ.
                  needToSend = true;
                  break;
              }
          }
      }

      // Transmit
      CSParams.pktCh[key] = valueArray;
      for (var cid in CSParams.Connections)
      {
          if (CSParams.Connections[cid].force || needToSend)
          {
              Transmit.senddata(cid, value);
          }
      }

      if (needToSend && tcpConnected){
          // extension.senddata('', value);
      }
  }
}));
