define([], function(){
  var storageHandlers={};
  function setHandler(key, handler)
  {
    if (storageHandlers[key])
    {
      delete storageHandlers[key];
    }

    if (handler)
    {
      storageHandlers[key] = handler;
    }
  }

  function handler(e){
    if (storageHandlers[e.key] instanceof Function)
    {
      fn = storageHandlers[e.key];
      fn(e);
    }
  }

  return {
    handlers: {
      set: setHandler,
      list: storageHandlers
    },
    handler: handler
  };
});
