(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define(['logger'],factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
        require('logger')
      );
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(this, function(log) {
  return log.debug;
}))
