function addRow(tableID, line) {

  var values = line.split('|');
  var label = values[1];
  var url = values[2];

  var table = document.getElementById(tableID);

  var rowCount = table.rows.length;
  var row = table.insertRow(rowCount);

  var cell1 = row.insertCell(0);
  var element1 = document.createElement('img');
  element1.src = 'images/chrome.png';
  element1.height = '16';
  element1.width = '16';
  cell1.appendChild(element1);

  var cell2 = row.insertCell(1);
  var aElemTN = document.createTextNode(label);
  cell2.appendChild(aElemTN);

  var cell3 = row.insertCell(2);
  var aElem = document.createElement('a');
  aElemTN = document.createTextNode(url);
  if (url.substr(0, 4) != 'http' && url.substr(0, 6) != 'chrome') {
      url = 'http://' + url;
    }
  aElem.href = url;
  aElem.appendChild(aElemTN);
        cell3.appendChild(aElem);

}

function addLinks() {

  var approvedLinks = localStorage.approvedWebList.split(',');
  for (var link in approvedLinks) {
    if (approvedLinks[link] !== '') {
      addRow('approvedList', approvedLinks[link]);
    }
  }
}

require(['modules/translate'], function(Translate){
  addLinks();
  Translate();
});
//CHeese
